﻿package
{
	import flash.display.Sprite;
	import flash.geom.Rectangle;
	import common.Framework;
	import common.AppInfo;
	import game.system.KeyWatcher;
	import game.system.ObjectManager;
	import game.system.SceneController;
	import game.scene.LoadingScene;
	
	public class agrsouko extends Sprite
	{
		private var framework:Framework;
		private var scenecontroller:SceneController;
		
		public function agrsouko()
		{
			framework = new Framework(this, main, 320, 240);
			framework.screen.setScale(2, 2);
			
			if(AppInfo.isVersion(9,0,60))
			{
				stage.fullScreenSourceRect = new Rectangle(0, 0, 640, 480);
			}
			
			KeyWatcher.watch("LEFT",  37, 100, 65);
			KeyWatcher.watch("UP",    38, 104, 87);
			KeyWatcher.watch("RIGHT", 39, 102, 68);
			KeyWatcher.watch("DOWN",  40, 98, 83);
			KeyWatcher.watch("BTN_A", 90, 75);
			KeyWatcher.watch("BTN_B", 16, 88, 74);
			KeyWatcher.watch("ENTER", 13);
			
			ObjectManager.addPriority("PRIO_BG");
			ObjectManager.addPriority("PRIO_PLAYER");
			ObjectManager.addPriority("PRIO_BOX");
			ObjectManager.addPriority("PRIO_CHECKPOINT");
			ObjectManager.addPriority("PRIO_BOX_TOP");
			ObjectManager.addPriority("PRIO_EFFECT");
			ObjectManager.addPriority("PRIO_SYSTEM");
			
			ObjectManager.addDepth("DEPTH_DISTANT");
			ObjectManager.addDepth("DEPTH_WALL_TOP");
			ObjectManager.addDepth("DEPTH_BOX_TOP");
			ObjectManager.addDepth("DEPTH_BOX");
			ObjectManager.addDepth("DEPTH_PLAYER");
			ObjectManager.addDepth("DEPTH_WALL");
			ObjectManager.addDepth("DEPTH_GUIDE");
			ObjectManager.addDepth("DEPTH_EFFECT");
			ObjectManager.addDepth("DEPTH_MESSAGE");
			ObjectManager.addDepth("DEPTH_SYSTEM");
			
			scenecontroller = new SceneController();
			scenecontroller.screen = framework.screen;
			
			scenecontroller.changeScene(new LoadingScene());
			
			//addChild(new DebugWindow());
		}
		
		private function main():void
		{
			scenecontroller.main();
			return;
		}
	}
}

import flash.text.TextField;
import flash.text.TextFormat;
import flash.utils.setInterval;

class DebugWindow extends TextField
{
	public function DebugWindow()
	{
		var format:TextFormat = new TextFormat();
		format.size = 9;
		defaultTextFormat = format;
		
		background = true;
		backgroundColor = 0x000000;
		textColor = 0xFFFFFF;
		selectable = false;
		
		width = 150;
		height = 1;
		
		setInterval(update, 1000);
		return;
	}
	
	private function update():void
	{
		text = TimeWatcher.output();
		height = textHeight+4;
		return;
	}
}