﻿
import flash.display.*;
import flash.events.Event;
import flash.utils.ByteArray;
import common.MultiLoader;
import game.system.*;
import game.obj.player.PlayerGraphic;

private var bmp_main:Bitmap = new Bitmap(new BitmapData(96, 56, false, 0x008080));
private var bmp_thumbnail:Bitmap = new Bitmap(new BitmapData(520, 48, false, 0x008080));

private var plygrp:PlayerGraphic;

private var labels:Array;
private var grplist:Array;

private var currentframe:String = "STAND";
private var parts:String = "body";

private function init():void
{
	//parent.stage.quality = StageQuality.LOW;
	
	plygrp = new PlayerGraphic();
	
	labels = new Array(
		"STAND",
		"CROUCH",
		"RUN1",
		"RUN2",
		"RUN3",
		"RUN4",
		"FURIMUKI",
		"JUMP",
		"FALL1",
		"FALL2",
		"ROT1",
		"ROT2",
		"ROT3"
	);
	grplist = new Array(
		"",
		"CROUCH",
		"STAND",
		"FURIMUKI",
		"JUMP",
		"FALL1",
		"FALL2",
		"RUN1",
		"RUN2",
		"RUN3",
		"RUN4",
		"ROT1",
		"ROT2",
		"ROT3",
		"HAND_STAND",
		"HAND_CROUCH",
		"HAND_RUN",
		"HAND_FALL",
		"HAND_GRAPPLE"
	);
	
	list_frame.dataProvider = labels;
	list_grp.dataProvider = grplist;
	
	bmp_main.scaleX = 6;
	bmp_main.scaleY = 6;
	
	img_main.width = bmp_main.width;
	img_main.height = bmp_main.height;
	
	img_main.addChild(bmp_main);
	img_thumbnail.addChild(bmp_thumbnail);
	
	update();
	return;
}

private function update():void
{
	//画面クリア
	bmp_main.bitmapData.fillRect(bmp_main.bitmapData.rect, 0x008080);
	bmp_thumbnail.bitmapData.fillRect(bmp_thumbnail.bitmapData.rect, 0x008080);
	
	//設定をパネルに反映
	parts_x.value = plygrp.frames[currentframe][parts+"_x"];
	parts_y.value = plygrp.frames[currentframe][parts+"_y"];
	
	if(parts == "head") {
		list_grp.enabled = false;
	}
	else {
		list_grp.enabled = true;
		list_grp.selectedItem = plygrp.frames[currentframe][parts+"_grp"];
	}
	
	//値設定をプレイヤーに反映
	if(radio_muki.selectedValue != null) {
		plygrp.muki = String(radio_muki.selectedValue);
	}
	plygrp.invert = checkbox_invert.selected;
	plygrp.grapple = checkbox_grapple.selected;
	plygrp.close_eye = checkbox_eye.selected;
	
	//描画
	plygrp.frame = currentframe;
	plygrp.draw(bmp_main.bitmapData, 48, 48);
	
	for(var i:int = 0; i < labels.length; i++)
	{
		plygrp.frame = labels[i];
		plygrp.draw(bmp_thumbnail.bitmapData, 20+40*i, 48);
	}
	return;
}

// --------------------------------//
// 設定
// --------------------------------//
private function select_frame():void
{
	currentframe = list_frame.selectedLabel;
	update();
	return;
}

private function select_parts():void
{
	parts = list_parts.selectedItem.data;
	update();
	return;
}

private function select_grp():void
{
	plygrp.frames[currentframe][parts+"_grp"] = list_grp.selectedLabel;
	update();
	return;
}

private function move_parts():void
{
	plygrp.frames[currentframe][parts+"_x"] = parts_x.value;
	plygrp.frames[currentframe][parts+"_y"] = parts_y.value;
	update();
	return;
}

// --------------------------------//
// 保存
// --------------------------------//
private function save():void
{
	var bin:ByteArray = new ByteArray();
	for(var i:int = 0; i < labels.length; i++)
	{
		//bin.writeObject(plygrp.frames[labels[i]]);
		var plyframe:Object = plygrp.frames[labels[i]];
		bin.writeUTF(labels[i]);
		bin.writeUTF(plyframe.body_grp);
		bin.writeByte(plyframe.body_x);
		bin.writeByte(plyframe.body_y);
		bin.writeByte(plyframe.head_x);
		bin.writeByte(plyframe.head_y);
		bin.writeUTF(plyframe.hand1_grp);
		bin.writeByte(plyframe.hand1_x);
		bin.writeByte(plyframe.hand1_y);
		bin.writeUTF(plyframe.hand2_grp);
		bin.writeByte(plyframe.hand2_x);
		bin.writeByte(plyframe.hand2_y);
	}
	bin.compress();
	output("player.dat", bin);
	return;
}

private function output(name:String, data:ByteArray):void
{
	var bin:ByteArray = new ByteArray();
	bin.writeByte(name.length);
	bin.writeMultiByte(name, "euc-jp");
	bin.writeBytes(data);
	
	var req:URLRequest = new URLRequest();
	req.url = "output.cgi";
	req.data = bin;
	req.method = URLRequestMethod.POST;
	
	sendToURL(req);
	//navigateToURL(req, "_blank");
}




// --------------------------------//
// ロード
// --------------------------------//
private var loader:MultiLoader = new MultiLoader();
private var databaseloader:DatabaseLoader;
private var itemlist:Array = new Array();

private function loading():void
{
	loader.loadXML("XML_DATABASE", "filelist.xml");
	addEventListener(Event.ENTER_FRAME, act_standbyloading);
	return;
}

public function act_standbyloading(e:Event):void
{
	if(loader.isComplete())
	{
		Database.addItem("XML_DATABASE", loader.getContent("XML_DATABASE"));
		databaseloader = new DatabaseLoader(new XML(Database.getItem("XML_DATABASE")));
		
		removeEventListener(Event.ENTER_FRAME, act_standbyloading);
		addEventListener(Event.ENTER_FRAME, act_loading);
		return;
	}
}

private function act_loading(e:Event):void
{
	if(databaseloader.isComplete())
	{
		GraphicConverter.convert(new XML(Database.getItem("XML_GRAPHIC")));
		
		removeEventListener(Event.ENTER_FRAME, act_loading);
		addEventListener(Event.ENTER_FRAME, act_convert);
		return;
	}
}

private function act_convert(e:Event):void
{
	if(GraphicConverter.isComplete())
	{
		removeEventListener(Event.ENTER_FRAME, act_convert);
		currentState = "main";
	}
}
