﻿package common
{
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.system.Capabilities;
	
	public class AppInfo
	{
		private static var root:Sprite;
		private static var stage:Stage;
		
		private static var fps:FPS = null;
		
		public static function registerMainSprite(sprite:Sprite):void
		{
			root = sprite;
			stage = sprite.stage;
			return;
		}
		
		// --------------------------------//
		// バージョンチェック
		// --------------------------------//
		public static function isVersion(major:int, minor:int = 0, build:int = 0, revision:int = 0):Boolean
		{
			var currentver:Array = Capabilities.version.split(/[ ,]/);
			var checkver:Array = ["", major, minor, build, revision];
			
			for (var i:int = 1; i < checkver.length; i++)
			{
				if (currentver[i] > checkver[i]) {return true;}
				if (currentver[i] < checkver[i]) {return false;}
			}
			return true;
		}
		
		// --------------------------------//
		// プロパティ
		// --------------------------------//
		public static function set frameRate(num:Number):void {stage.frameRate = num;}
		public static function get frameRate():Number {return stage.frameRate;}
		
		public static function viewFPS():void
		{
			if(fps != null) {return;}
			
			fps = new FPS();
			root.addChild(fps);
		}
		
		public static function hideFPS():void
		{
			if(fps == null) {return;}
			
			root.removeChild(fps);
			fps = null;
		}
		
		public static var frameSkip:Boolean = false;
		public static var interval:uint = 0;
	}
}

import flash.display.Bitmap;
import flash.events.Event;
import flash.utils.setInterval;
import flash.display.BitmapData;

class FPS extends Bitmap
{
	private var bmp:BitmapData = new BitmapData(8*8, 8, true, 0);
	private var count:int = 0;
	
	public function FPS()
	{
		func_text.draw("SYSTEM", bmp, "FPS = ", 0, 0);
		bitmapData = bmp;
		
		x = 2;
		y = 2;
		scaleX = 2;
		scaleY = 2;
		
		addEventListener(Event.ENTER_FRAME, onEnterFrame);
		setInterval(update, 1000);
	}
	
	private function onEnterFrame(event:Event):void
	{
		count++;
	}
	
	private function update():void
	{
		func_text.draw("SYSTEM", bmp, "FPS = "+count, 0, 0);
		count = 0;
	}
}