package common
{
	import flash.display.InteractiveObject;
	import flash.events.KeyboardEvent;
	import flash.events.FocusEvent;
	
	public class Key
	{
		private static var down:Array = new Array(256);
		
		// --------------------------------//
		// リスナー
		// --------------------------------//
		public static function setListener(target:InteractiveObject):void
		{
			target.stage.focus = target;
			
			target.addEventListener(KeyboardEvent.KEY_DOWN, onKeyDown);
			target.addEventListener(KeyboardEvent.KEY_UP, onKeyUp);
			target.addEventListener(FocusEvent.FOCUS_OUT, onFocusOut);
		}
		
		private static function onKeyDown(event:KeyboardEvent):void
		{
			down[event.keyCode] = true;
		}
		
		private static function onKeyUp(event:KeyboardEvent):void
		{
			down[event.keyCode] = false;
		}
		
		private static function onFocusOut(event:FocusEvent):void
		{
			event.currentTarget.stage.focus = event.currentTarget;
			
			//キーを押しながらフォーカスを外すと押しっぱなしになる現象の対策
			for(var i:String in down)
			{
				down[i] = false;
			}
		}
		
		// --------------------------------//
		// 取得
		// --------------------------------//
		public static function isDown(keycode:int):Boolean
		{
			return down[keycode];
		}
	}
}