package game.obj.player
{
	import game.system.*;
	import common.DisplayImage;
	import flash.display.BitmapData;
	import flash.geom.Point;
	import flash.utils.ByteArray;
	
	public class PlayerGraphic
	{
		private var data:GraphicData;
		private var point:Point = new Point();
		
		public var frames:Array = new Array();
		public var frame:String = "STAND";
		public var invert:Boolean = false;
		
		public var muki:String = "F";
		public var grapple:Boolean = false;
		public var close_eye:Boolean = false;
		
		public function PlayerGraphic()
		{
			data = Database.getItem("GRP_PLAYER");
			/*
			var labels:Array = new Array(
				"STAND",
				"CROUCH",
				"RUN1",
				"RUN2",
				"RUN3",
				"RUN4",
				"FURIMUKI",
				"JUMP",
				"FALL1",
				"FALL2",
				"ROT1",
				"ROT2",
				"ROT3"
			);
			
			for(var i:int = 0; i < labels.length; i++)
			{
				addFrame(labels[i]);
			}
			*/
			
			var bin:ByteArray = new ByteArray();
			bin.writeBytes(Database.getItem("DAT_PLAYER"));
			bin.uncompress();
			for( ; bin.bytesAvailable > 0; )
			{
				var plyframe:Frame = addFrame(bin.readUTF());
				plyframe.body_grp = bin.readUTF();
				plyframe.body_x = bin.readByte();
				plyframe.body_y = bin.readByte();
				plyframe.head_x = bin.readByte();
				plyframe.head_y = bin.readByte();
				plyframe.hand1_grp = bin.readUTF();
				plyframe.hand1_x = bin.readByte();
				plyframe.hand1_y = bin.readByte();
				plyframe.hand2_grp = bin.readUTF();
				plyframe.hand2_x = bin.readByte();
				plyframe.hand2_y = bin.readByte();
			}
			return;
		}
		
		private function addFrame(label:String):Frame
		{
			frames[label] = new Frame();
			return frames[label];
		}
		
		public function draw(surface:BitmapData, x:int, y:int):void
		{
			if(frame == "") {return;}
			
			var drawParts:Function = function(label:String, offset_x:int, offset_y:int):void
			{
				if(label == "") {return;}
				
				if(invert == false) {
					var img:DisplayImage = data.frames[label].img;
					point.x = x + offset_x - img.cx;
				}
				else {
					var img:DisplayImage = data.frames[label].variation["INVERT"];
					point.x = x - offset_x - img.cx;
				}
				
				point.y = y + offset_y - img.cy;
				surface.copyPixels(img.bmp, img.rect, point);
			}
			
			if(grapple == true && frame.substr(0, 3) == "ROT") {frame = "JUMP";}
			var plyframe:Frame = frames[frame];
			
			drawParts(plyframe.body_grp, plyframe.body_x, plyframe.body_y);
			
			if(frame.substr(0, 3) != "ROT")
			{
				if(frame == "FURIMUKI")    {drawParts("HEAD3_"+muki, plyframe.head_x, plyframe.head_y);}
				else if(close_eye == true) {drawParts("HEAD2_"+muki, plyframe.head_x, plyframe.head_y);}
				else                       {drawParts("HEAD1_"+muki, plyframe.head_x, plyframe.head_y);}
			}
			
			if(grapple == true) {drawParts(plyframe.hand2_grp, plyframe.hand2_x, plyframe.hand2_y);}
			else                {drawParts(plyframe.hand1_grp, plyframe.hand1_x, plyframe.hand1_y);}
		}
	}
}

class Frame
{
	public var body_grp:String = "STAND";
	public var body_x:int = 0;
	public var body_y:int = 0;
	public var head_x:int = 0;
	public var head_y:int = -27;
	public var hand1_grp:String = "HAND_STAND";
	public var hand1_x:int = -5;
	public var hand1_y:int = -32;
	public var hand2_grp:String = "HAND_GRAPPLE";
	public var hand2_x:int = 8;
	public var hand2_y:int = -24;
}
