package game.obj.system
{
	import game.obj.GameObject;
	import game.system.Database;
	import game.system.Graphic;
	import flash.geom.Rectangle;
	import game.obj.box.BoxBase;
	import game.obj.box.Box;
	import game.obj.effect.RectVanish;
	import common.List;
	
	public class CheckPoint extends GameObject
	{
		public var enter:Boolean = false;
		
		override public function init():void
		{
			registerObject("PRIO_CHECKPOINT", "DEPTH_WALL");
			grp = new Graphic("GRP_CHECKPOINT");
			
			changeAction("act_main");
			return;
		}
		
		public function act_main():void
		{
			var boxlist:List = scene.func_obj.searchPriority("PRIO_BOX");
			var hit:Boolean = false;
			
			boxlist.forEach(function(box:BoxBase):void
			{
				if(box is Box)
				{
					if(box.x > x-6 && box.x < x+6 && box.y == y && box.isActive() == false)
					{
						box.grp.frame = "DARK";
						hit = true;
					}
				}
			});
			
			if(hit == true)
			{
				if(enter == false) {
					createObject(new RectVanish());
				}
				
				enter = true;
				visible = false;
			}
			else
			{
				enter = false;
				visible = true;
			}
			
			//アニメ
			grp.frame = Math.floor(count/4 % 8).toString();
		}
	}
}