package game.obj.system
{
	import game.obj.GameObject;
	import flash.display.BitmapData;
	import flash.geom.Point;
	
	public class MenuItem extends GameObject
	{
		public var width:int;
		public var height:int;
		public var linespace:int = 0;
		
		public var label:String;
		public var button:Boolean;
		public var data:Array;
		
		public var selected:Boolean = false;
		
		private var currentfont:String;
		public var font_normal:String = "16x8_blue";
		public var font_select:String = "16x8_orange";
		
		private var _index:int = 0;
		private var _currentdata:String = null;
		
		public function MenuItem(label:String, button:Boolean = true, data:Array = null):void
		{
			this.label = label;
			this.button = button;
			this.data = data;
			
			currentfont = font_normal;
			
			if(data != null) {
				_currentdata = data[0];
			}
			
			return;
		}
		
		override public function init():void
		{
			registerObject("PRIO_SYSTEM", "DEPTH_MESSAGE");
			update();
		}
		
		public function update():void
		{
			if(selected == true) {
				currentfont = font_select;
			}
			else {
				currentfont = font_normal;
			}
			
			height = func_text.getTextHeight(currentfont, label);
			return;
		}
		
		// --------------------------------//
		// プロパティ
		// --------------------------------//
		public function get index():int {return _index;}
		public function set index(num:int):void
		{
			_index = num;
			_currentdata = data[_index];
		}
		
		public function get currentdata():String {return _currentdata;}
		public function set currentdata(name:String):void
		{
			for(var i:int = 0; i < data.length; i++)
			{
				if(data[i] == name)
				{
					index = i;
					return;
				}
			}
		}
		
		// --------------------------------//
		// 描画
		// --------------------------------//
		override public function draw(surface:BitmapData):void
		{
			var x:Number = this.x;
			
			if(selected == true) {
				x += 4;
			}
			
			update();
			
			if(label != "") {
				func_text.draw(currentfont, surface, label, x, y);
			}
			
			if(currentdata != null)
			{
				var textwidth:int = func_text.getTextWidth(font_select, currentdata);
				func_text.draw(currentfont, surface, currentdata, this.x+width-textwidth, y);
			}
		}
	}
}
