package game.scene
{
	import game.system.*;
	import common.AppInfo;
	import flash.display.Loader;
	import flash.utils.ByteArray;
	import common.PNGData;
	import flash.display.BitmapData;
	import flash.geom.ColorTransform;
	
	public class InitializeScene extends SceneBase
	{
		override public function init():void
		{
			func_bgm.setMasterVolume(0);
			func_se.setMasterVolume(0);
			
			changeAction("act_setup");
		}
		
		public function act_setup():void
		{
			Database.getItem("DAT_STAGE").uncompress();
			
			//登録
			var table:String = " ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-'./㍗";
			func_text.addFont("16x8_blue", Database.getItem("BMP_16X8TEXT_BLUE"), table, 8, 16);
			func_text.addFont("16x8_orange", Database.getItem("BMP_16X8TEXT_ORANGE"), table, 8, 16);
			
			var table:String = ""
			 + " 0123456789ABCDE"
			 + "FGHIJKLMNOPQRSTU"
			 + "VWXYZ_-=+\\|[]()/"
			 + "?!@#%^&*~`:;.,←㍗";
			func_text.addFont("8px", Database.getItem("BMP_8PXTEXT"), table, 8, 8);
			
			var temp:BitmapData = Database.getItem("BMP_8PXTEXT").clone();
			temp.colorTransform(temp.rect, new ColorTransform(0.8, 0.9, 1.0, 0.5));
			func_text.addFont("8px_trans", temp, table, 8, 8);
			
			changeAction("act_load");
		}
		
		// --------------------------------//
		// 記録読み込み
		// --------------------------------//
		public function act_load():void
		{
			var temp:Array = [PlayData.ranking, PlayData.records, PlayData.replays, PlayData.option];
			
			for each(var localdata:LocalData in temp)
			{
				if(localdata.isEmpty() == true)
				{
					localdata.initialize();
					localdata.saveData();
				}
				else {
					localdata.loadData();
				}
				
				if(localdata.isError() == true)
				{
					localdata.initialize();
					localdata.saveData();
				}
			}
			
			if(PlayData.option.data.fps == "ON")
			{
				AppInfo.viewFPS();
			}
			
			changeAction("act_grpconv");
		}
		
		// --------------------------------//
		// 画像切り出し
		// --------------------------------//
		public function act_grpconv():void
		{
			if(count == 0)
			{
				var palette:ByteArray;
				
				switch(PlayData.option.data.palette)
				{
				case "NORMAL":palette = new PNGData(Database.getItem("PNG_PAL1")).palette; break;
				case "NIGHT":palette = new PNGData(Database.getItem("PNG_PAL2")).palette; break;
				case "PASTEL":palette = new PNGData(Database.getItem("PNG_PAL3")).palette; break;
				case "VECTOR-LIKE":palette = new PNGData(Database.getItem("PNG_PAL4")).palette; break;
				case "RANDOM":
					palette = new ByteArray();
					palette.writeMultiByte("PLTE", "us-ascii");
					for(var i:int = 0; i < 768; i++) {
						palette.writeByte(Math.random()*0x100);
					}
					break;
				}
				GraphicConverter.convert(new XML(Database.getItem("XML_GRAPHIC")), palette);
			}
			
			if(GraphicConverter.isComplete())
			{
				changeAction("act_complete");
			}
		}
		
		public function act_complete():void
		{
			changeScene(new TitleScene());
		}
	}
}