package game.scene
{
	import game.system.*;
	import common.MultiLoader;
	import common.AppInfo;
	import flash.display.BitmapData;
	import flash.net.LocalConnection;
	import flash.utils.getTimer;
	
	public class LoadingScene extends SceneBase
	{
		private var loader:MultiLoader = new MultiLoader();
		private var databaseloader:DatabaseLoader;
		private var itemlist:Array = new Array();
		private var localconnection:LocalConnection = new LocalConnection();
		private var systext:String = "";
		
		override public function init():void
		{
			changeAction("act_standbyloading");
		}
		
		// --------------------------------//
		// 描画
		// --------------------------------//
		override public function draw(surface:BitmapData):void
		{
			screen.clear();
			
			if(systext != "")
			{
				var height:int = func_text.getTextHeight("SYSTEM", systext);
				func_text.draw("SYSTEM", surface, systext, 4, 240-4-height);
			}
		}
		
		// --------------------------------//
		// ローディング
		// --------------------------------//
		public function act_standbyloading():void
		{
			if(count == 0)
			{
				loader.loadBitmap("BMP_SYSFONT", "graphic/sysfont.png");
				loader.loadXML("XML_DATABASE", "filelist.xml");
			}
			
			if(loader.isComplete())
			{
				Database.addItem("BMP_SYSFONT", loader.getContent("BMP_SYSFONT"));
				Database.addItem("XML_DATABASE", loader.getContent("XML_DATABASE"));
				
				//文字登録
				var table:String = ""
				 + " ABCDEFGHIJKLMNOPQRSTUVWXYZabcde"
				 + "fghijklmnopqrstuvwxyz0123456789-"
				 + "=\\!@#$%^&*()_+|[]{};:'\",.<>/?`~";
				func_text.addFont("SYSTEM", Database.getItem("BMP_SYSFONT"), table, 6, 8);
				
				databaseloader = new DatabaseLoader(new XML(Database.getItem("XML_DATABASE")));
				changeAction("act_loading");
			}
		}
		
		public function act_loading():void
		{
			systext = databaseloader.systext;
			
			if(databaseloader.isComplete())
			{
				systext = "WAIT...";
				changeAction("act_tunefps");
			}
		}
		
		// --------------------------------//
		// FPS調整
		// --------------------------------//
		private var destfps:Number;
		private var pretimer:Number;
		
		public function act_tunefps():void
		{
			if(count == 0)
			{
				destfps = AppInfo.frameRate;
				pretimer = getTimer();
			}
			else if(count % 18 == 0)
			{
				var timer:Number = getTimer()-pretimer;
				systext = "WAIT... "+(1000/destfps*18)+" / "+timer.toString();
				pretimer = getTimer();
				
				if(timer < (1000/destfps*18)-20)	//早すぎる
				{
					AppInfo.frameRate -= 2.5;
				}
				else if(timer > (1000/destfps*18)+20)	//遅すぎる
				{
					AppInfo.frameRate += 5;
				}
				else	//丁度
				{
					systext = "";
					changeAction("act_gotomaingame");
					return;
				}
			}
			
			if(count == 18*16)	//時間切れ
			{
				changeAction("act_gotomaingame");
				return;
			}
		}
		
		// --------------------------------//
		// シーン変更
		// --------------------------------//
		public function act_gotomaingame():void
		{
			changeScene(new InitializeScene());
		}
	}
}