package game.system
{
	import flash.net.LocalConnection;
	import flash.events.StatusEvent;
	import flash.events.SecurityErrorEvent;
	
	public class BGM
	{
		private var lc:LocalConnection = new LocalConnection();
		private var playflag:Boolean = false;
		
		public function BGM()
		{
			//エラーイベントの処理
			lc.addEventListener
			(
				StatusEvent.STATUS,
				function(event:StatusEvent):void
				{
					if(event.level != "status") {
						trace(event.level);
					}
				}
			);
		}
		
		// --------------------------------//
		// 曲の再生
		// --------------------------------//
		public function play(name:String):void
		{
			playflag = true;
			lc.send("BGM", "attachSound", name);
			
			switch (name)
			{
			case "BGM_COURSE1" :
				lc.send("BGM", "play", 61.6, -56.5);
				break;
			case "BGM_COURSE2" :
				lc.send("BGM", "play", 80.6, -65.8);
				break;
			case "BGM_MENU" :
				lc.send("BGM", "play", 28.5, -27.43);
				break;
			case "BGM_ENTRY" :
				lc.send("BGM", "play", 13, -11.7);
				break;
			case "BGM_STANDBY" :
				lc.send("BGM", "play", 14, -11.23);
				break;
			}
			
			return;
		}
		
		// --------------------------------//
		// その他
		// --------------------------------//
		public function main():void
		{
			if(playflag == true) {
				lc.send("BGM", "main");
			}
		}
		public function stop():void
		{
			playflag = false;
			lc.send("BGM", "stop");
		}
		
		public function fadeout():void {lc.send("BGM", "fadeout");}
		public function setVolume(num:Number):void {lc.send("BGM", "setVolume", num);}
		public function setMasterVolume(num:Number):void {lc.send("BGM", "setMasterVolume", num);}
	}
}
