package game.system
{
	import common.MultiLoader;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.net.LocalConnection;
	
	public class DatabaseLoader
	{
		private var loader:MultiLoader = new MultiLoader();
		private var itemlist:Array = new Array();
		
		private var localconnection:LocalConnection = new LocalConnection();
		private var listener:Sprite = new Sprite();
		
		public var systext:String = "";
		private var iscomplete:Boolean = false;
		
		public function DatabaseLoader(xml:XML):void
		{
			//読み込み用リスト作成
			var xmllist:XMLList = xml.children();
			
			for(var i:int = 0; i < xmllist.length(); i++)
			{
				var elem:XML = xmllist[i];
				
				switch(elem.localName())
				{
				case "file":
					itemlist.push({type:elem.@type.toString(), name:elem.@name.toString(), url:elem.@src.toString()});
					break;
				}
			}
			
			if(localconnection.domain == "localhost")
			{
				for each(var item:Object in itemlist)
				{
					loader.load(item.type, item.name, item.url);
				}
				listener.addEventListener(Event.ENTER_FRAME, act_localloading);
			}
			else {
				listener.addEventListener(Event.ENTER_FRAME, act_networkloading);
			}
			return;
		}
		
		// --------------------------------//
		// 各種データ読み込み
		// --------------------------------//
		private var item:Object = null;
		
		//ネットワーク上では１つづつ読み込む
		public function act_networkloading(e:Event):void
		{
			if(item == null)
			{
				item = itemlist.shift();
				loader.load(item.type, item.name, item.url);
				
				systext = "NOWLOADING... "+item.name;
			}
			
			if(loader.isError())
			{
				listener.removeEventListener(Event.ENTER_FRAME, act_networkloading);
				error();
				return;
			}
			
			if(loader.isComplete())
			{
				switch(item.type)
				{
				default: Database.addItem(item.name, loader.getContent(item.name)); break;
				case "SOUND": func_se.addSound(item.name, loader.getContent(item.name)); break;
				}
				
				item = null;
				
				//ロード完了
				if(itemlist.length == 0)
				{
					listener.removeEventListener(Event.ENTER_FRAME, act_networkloading);
					iscomplete = true;
					return;
				}
			}
		}
		
		//ローカルではまとめて読み込む
		public function act_localloading(e:Event):void
		{
			if(loader.isError())
			{
				listener.removeEventListener(Event.ENTER_FRAME, act_localloading);
				error();
				return;
			}
			
			if(loader.isComplete())
			{
				for each(var item:* in itemlist)
				{
					switch(item.type)
					{
					default: Database.addItem(item.name, loader.getContent(item.name)); break;
					case "SOUND": func_se.addSound(item.name, loader.getContent(item.name)); break;
					}
				}
				
				listener.removeEventListener(Event.ENTER_FRAME, act_localloading);
				iscomplete = true;
				return;
			}
		}
		
		public function error():void
		{
			systext = "";
			
			for each(var name:String in loader.getErrorFiles())
			{
				systext += "\nERROR! NOT FOUND - "+name;
			}
		}
		
		public function isComplete():Boolean
		{
			return iscomplete;
		}
	}
}