package game.system
{
	import game.system.Database;
	import common.DisplayImage;
	import flash.display.BitmapData;
	import flash.geom.Point;
	
	public class Graphic
	{
		private var data:GraphicData;
		private var frames:Array;
		private var point:Point = new Point();
		
		public var frame:String = "";
		public var type:String = "NORMAL";
		
		public function Graphic(name:String)
		{
			data = Database.getItem(name);
			frames = data.frames;
		}
		
		public function draw(surface:BitmapData, x:int, y:int):void
		{
			if(frame == "") {return;}
			
			if(type == "NORMAL") {
				var img:DisplayImage = frames[frame].img;
			}
			else {
				var img:DisplayImage = frames[frame].variation[type];
			}
			
			point.x = x - img.cx;
			point.y = y - img.cy;
			surface.copyPixels(img.bmp, img.rect, point);
		}
	}
}