package game.system
{
	import flash.display.BitmapData;
	import flash.geom.Rectangle;
	import flash.geom.Point;
	import common.DisplayImage;
	
	public class GraphicData
	{
		public var frames:Array = new Array();
		
		internal function addFrame(label:String, bmp:BitmapData, rect:Rectangle, cx:int = 0, cy:int = 0):void
		{
			frames[label] = new Frame(bmp, rect, cx, cy);
		}
		
		internal function addVariation(name:String, effect:Function, args:Array):void
		{
			if(args == null) {args = new Array();}
			
			for each(var frame:Frame in frames)
			{
				args.unshift(frame.img);
				frame.variation[name] = effect.apply(this, args);
				args.shift();
			}
		}
	}
}

import flash.display.BitmapData;
import flash.geom.Rectangle;
import flash.geom.Point;
import common.DisplayImage;

class Frame
{
	public var img:DisplayImage;
	public var variation:Object = new Object();
	
	public function Frame(bmp:BitmapData, rect:Rectangle, cx:int, cy:int)
	{
		var temp:BitmapData = new BitmapData(rect.width, rect.height, true, 0);
		temp.copyPixels(bmp, rect, new Point(0, 0));
		img = new DisplayImage(temp, cx, cy);
	}
}
