package game.system
{
	import flash.utils.ByteArray;
	
	public class ReplayEncoder
	{
		private static var keylist:Array = new Array("LEFT", "UP", "RIGHT", "DOWN", "BTN_A", "BTN_B");
		
		public static function encode(log:Array):ByteArray
		{
			var bytes:ByteArray = new ByteArray();
			var byte:int;
			
			for(var i:int = 0; i < log.length; i++)
			{
				byte = 0;
				
				for(var j:int = 0; j < keylist.length; j++) {
					if(log[i][keylist[j]] == true) {byte += 1 << j;}
				}
				bytes.writeByte(byte);
			}
			
			bytes.compress();
			return bytes;
		}
		
		public static function decode(bytes:ByteArray):Array
		{
			var log:Array = new Array();
			var byte:int;
			
			bytes.position = 0;
			bytes.uncompress();
			
			for(var i:int = 0; i < bytes.length; i++)
			{
				log[i] = new Array();
				byte = bytes.readUnsignedByte();
				
				for(var j:int = 0; j < keylist.length; j++)
				{
					log[i][keylist[j]] = (byte & 1) == 1;
					byte >>>= 1;
				}
			}
			
			bytes.compress();
			return log;
		}
	}
}