package game.system
{
	import common.LocalDataManager;
	import flash.utils.ByteArray;
	
	public class ReplayRecords extends LocalData
	{
		public function ReplayRecords()
		{
			func_ldm = new LocalDataManager("replay");
			
			data.course = new Array();
			data.stage = new Array();
			data.stage[1] = new Array();
			data.stage[2] = new Array();
			
			for(var i:int = 1; i <= 2; i++) {
				func_ldm.setDefault("course"+i, {score:0, sequence:null});
			}
			for(var i:int = 1; i <= 6; i++) {
				func_ldm.setDefault("stage1-"+i, {time:90, replay:null});
			}
			for(var i:int = 1; i <= 8; i++) {
				func_ldm.setDefault("stage2-"+i, {time:90, replay:null});
			}
		}
		
		override public function initialize():void
		{
			func_ldm.initialize();
			
			for(var i:int = 1; i <= 2; i++) {data.course[i] = func_ldm.getDefault("course"+i);}
			for(var i:int = 1; i <= 6; i++) {data.stage[1][i] = func_ldm.getDefault("stage1-"+i);}
			for(var i:int = 1; i <= 8; i++) {data.stage[2][i] = func_ldm.getDefault("stage2-"+i);}
			return;
		}
		
		override public function saveData():void
		{
			for(var i:int = 1; i <= 2; i++) {func_ldm.saveData("course"+i, data.course[i]);}
			for(var i:int = 1; i <= 6; i++) {func_ldm.saveData("stage1-"+i, data.stage[1][i]);}
			for(var i:int = 1; i <= 8; i++) {func_ldm.saveData("stage2-"+i, data.stage[2][i]);}
			return;
		}
		
		override public function loadData():void
		{
			for(var i:int = 1; i <= 2; i++) {data.course[i] = func_ldm.loadData("course"+i);}
			for(var i:int = 1; i <= 6; i++) {data.stage[1][i] = func_ldm.loadData("stage1-"+i);}
			for(var i:int = 1; i <= 8; i++) {data.stage[2][i] = func_ldm.loadData("stage2-"+i);}
			return;
		}
		
		// --------------------------------//
		// 判定
		// --------------------------------//
		public function entryCourse(course:int, score:int, records:Array, sequence:Array):void
		{
			var error:Boolean = false;
			
			for(var i:int = 0; i < sequence.length; i++)
			{
				if(sequence[i] == null) {
					error == true;
				}
				else if(records[i] != null) {
					entryStage(course, i+1, records[i], sequence[i]);
				}
			}
			
			if(error == true) {return;}
			
			if(data.course[course].score < score)
			{
				data.course[course].score = score;
				data.course[course].sequence = sequence;
			}
			return;
		}
		
		public function entryStage(course:int, stage:int, time:Number, replay:ByteArray):void
		{
			if(replay == null) {return;}
			
			if(data.stage[course][stage].time > time)
			{
				data.stage[course][stage].time = time;
				data.stage[course][stage].replay = replay;
			}
			return;
		}
		
		public function getScore(course:int):String
		{
			if(data.course[course].sequence == null) {
				return "no data";
			}
			else {
				return data.course[course].score.toString()+"pts";
			}
		}
		
		public function getTime(course:int, stage:int):String
		{
			if(data.stage[course][stage].replay == null) {
				return "no data";
			}
			else {
				return GameData.timeToString(data.stage[course][stage].time);
			}
		}
	}
}
